var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { isNumber, isUndefined } from 'lodash';
import { useEffect, useRef } from 'react';
import { useAsync, useForceUpdate } from '@react-devui/hooks';
import { DCustomIcon } from '@react-devui/icons';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { registerComponentMate, TTANSITION_DURING_BASE } from '../../utils';
import { DTransition } from '../_transition';
import { useComponentConfig, usePrefixConfig } from '../root';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DSpinner' });
export function DSpinner(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dVisible = true, dText, dDelay, dSize = 28, dAlone = false, afterVisibleChange } = _a, restProps = __rest(_a, ["children", "dVisible", "dText", "dDelay", "dSize", "dAlone", "afterVisibleChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const spinnerRef = useRef(null);
    const containerRef = useRef(null);
    //#endregion
    const dataRef = useRef({
        delayVisible: false,
    });
    const async = useAsync();
    const forceUpdate = useForceUpdate();
    if (dVisible === false) {
        dataRef.current.delayVisible = false;
    }
    const visible = isUndefined(dDelay) ? dVisible : dataRef.current.delayVisible;
    useEffect(() => {
        if (isNumber(dDelay) && dVisible) {
            const asyncInstance = async.create();
            asyncInstance.setTimeout(() => {
                dataRef.current.delayVisible = true;
                forceUpdate();
            }, dDelay);
            return () => {
                asyncInstance.clearAll();
            };
        }
    }, [async, dDelay, dVisible, forceUpdate]);
    const transitionStyles = {
        enter: { opacity: 0 },
        entering: {
            transition: ['opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms linear`).join(', '),
        },
        leaving: {
            opacity: 0,
            transition: ['opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms linear`).join(', '),
        },
        leaved: { display: 'none' },
    };
    return (_jsx(DTransition, Object.assign({ dIn: visible, dDuring: TTANSITION_DURING_BASE, onEnter: () => {
            if (!dAlone && spinnerRef.current && containerRef.current) {
                containerRef.current.style.height = `${spinnerRef.current.offsetHeight}px`;
            }
        }, dDestroyWhenLeaved: true, afterEnter: () => {
            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
        }, afterLeave: () => {
            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
        } }, { children: (state) => (_jsx("div", Object.assign({}, restProps, { ref: spinnerRef, className: getClassName(restProps.className, `${dPrefix}spinner`, {
                [`${dPrefix}spinner--alone`]: dAlone,
            }), style: Object.assign(Object.assign({}, restProps.style), transitionStyles[state]) }, { children: _jsxs("div", Object.assign({ ref: containerRef, className: `${dPrefix}spinner__container` }, { children: [_jsx("div", Object.assign({ className: `${dPrefix}spinner__icon`, style: { fontSize: dSize } }, { children: checkNodeExist(children) ? (children) : (_jsx(DCustomIcon, Object.assign({ className: `${dPrefix}spinner__spinner-icon`, viewBox: "0 0 50 50" }, { children: _jsx("circle", { cx: "25", cy: "25", r: "21", fill: "none", stroke: "currentColor", strokeWidth: "4", strokeLinecap: "round" }) }))) })), checkNodeExist(dText) && _jsx("div", Object.assign({ className: `${dPrefix}spinner__text` }, { children: dText }))] })) }))) })));
}
