import type { DId } from '../../utils/types';
import type { DFormControl } from '../form';
import React from 'react';
export interface DTreeItem<V extends DId> {
    label: string;
    value: V;
    loading?: boolean;
    disabled?: boolean;
    children?: DTreeItem<V>[];
}
export interface DTreeProps<V extends DId, T extends DTreeItem<V>> extends Omit<React.HTMLAttributes<HTMLElement>, 'children'> {
    dFormControl?: DFormControl;
    dList: T[];
    dModel?: V | null | V[];
    dHeight?: number;
    dExpands?: V[];
    dShowLine?: boolean;
    dDisabled?: boolean;
    dMultiple?: boolean;
    dOnlyLeafSelectable?: boolean;
    dCustomItem?: (item: T) => React.ReactNode;
    onModelChange?: (value: any, item: any) => void;
    onFirstExpand?: (value: T['value'], item: T) => void;
    onExpandsChange?: (ids: T['value'][], items: T[]) => void;
}
export declare function DTree<V extends DId, T extends DTreeItem<V>>(props: DTreeProps<V, T>): JSX.Element | null;
